Package: org.codehaus.groovy.control

## [Java] Class AnnotationConstantsVisitor

- org.codehaus.groovy.control.AnnotationConstantsVisitor

-     public class AnnotationConstantsVisitor
      extends ClassCodeVisitorSupport

  Resolves constants in annotation definitions.

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected SourceUnit` | `getSourceUnit()` Returns the source unit currently being visited.
    `` | `public void` | `visitClass(ClassNode classNode, SourceUnit sourceUnit)` Visits an annotation definition and inlines constant values in its members.
    `` | `protected void` | `visitConstructorOrMethod(MethodNode node, boolean isConstructor)` Rewrites annotation member bodies so constant expressions are resolved eagerly.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ClassCodeVisitorSupport` | `addError, getSourceUnit, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop`
    `class CodeVisitorSupport` | `afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCastExpression, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression, visitWhileLoop`

- - ### Method Detail

    - #### protected SourceUnit getSourceUnit()

      Returns the source unit currently being visited.

      Returns:
        the active source unit

    - #### public void visitClass(ClassNode classNode, SourceUnit sourceUnit)

      Visits an annotation definition and inlines constant values in its members.

      Parameters:
        `classNode` - the annotation class to inspect
        `sourceUnit` - the owning source unit

    - #### protected void visitConstructorOrMethod(MethodNode node, boolean isConstructor)

      Rewrites annotation member bodies so constant expressions are resolved eagerly.

      Parameters:
        `node` - the constructor or method to inspect
        `isConstructor` - whether `node` is a constructor